diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
index c838aa0d5..72f55827f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererPlayer.java
@@ -2,15 +2,14 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.Minecraft;
 
-import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.entity.player.PlayerLocal;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.PlayerSkinParser;
-import net.minecraft.client.render.RenderBlocks;
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
-import net.minecraft.client.render.blockentity.TileEntityRenderer;
+import net.minecraft.client.render.tileentity.TileEntityRenderer;
 import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.model.ModelPlayer;
 import net.minecraft.client.render.model.ModelPlayerSlim;
@@ -31,7 +30,6 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
     private final ModelPlayer modelSlim;
 
     private BlocksContainer container = null;
-    private RenderBlocks containerRenderBlock = null;
 
     public MobRendererPlayer()
     {
@@ -45,9 +43,9 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
         mainModel = player.slimModel ? modelSlim : modelThick;
         modelBipedMain = player.slimModel ? modelSlim : modelThick;
 
-        modelBipedMain.onGround = 0.0F;
+        modelBipedMain.swingProgress = 0.0F;
         modelBipedMain.isRiding = false;
-        modelBipedMain.setupAnimation(0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0625F);
+        modelBipedMain.setupAnimation(player, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F, 0.0625F, 1f);
         if (isLeft){
             modelBipedMain.armLeft.render(0.0625F);
         } else {
@@ -68,7 +66,6 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
             CarriedBlock carriedBlock = (CarriedBlock)player.getHeldObject();
             if (container == null || container.world != player.world) {
                 container = new BlocksContainer(player.world);
-                containerRenderBlock = new RenderBlocks(container);
             }
 
             Tessellator tessellator = Tessellator.instance;
@@ -92,19 +89,18 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
             int blockY = MathHelper.floor(player.y) + 1;
             int blockZ = MathHelper.floor(player.z);
 
-            BlockModel.setRenderBlocks(containerRenderBlock);
             tessellator.startDrawingQuads();
             tessellator.setTranslation(-blockX -0.5, -blockY -0.5, -blockZ -0.5);
 
             container.setLightReferenceEntity(player);
             container.setBlock(blockX, blockY, blockZ, carriedBlock.blockId, carriedBlock.metadata, carriedBlock.entity);
-            BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block()).renderNoCulling(Tessellator.instance, blockX, blockY, blockZ);
+            BlockModelDispatcher.getInstance().getDispatch(carriedBlock.block()).renderNoCulling(Tessellator.instance, container, blockX, blockY, blockZ);
             tessellator.draw();
             tessellator.setTranslation(0, 0, 0);
             container.setLightReferenceEntity(null);
             container.clear();
 
-            TileEntityRenderer<TileEntity> renderer = BlockEntityRenderDispatcher.instance.getRenderer(carriedBlock.entity);
+            TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(carriedBlock.entity);
             if (renderer != null) {
                 carriedBlock.entity.worldObj = player.world;
                 renderer.doRender(tessellator, carriedBlock.entity, -0.5, -0.5, -0.5, partialTick);
@@ -116,7 +112,7 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
         }
     }
     @Override
-    protected void renderSpecials(Tessellator tessellator, Player entity, double d, double d1, double d2)
+    protected void renderSpecials(Tessellator tessellator, Player entity, double x, double y, double z)
     {
         if (Minecraft.getMinecraft().thePlayer.getGamemode() != Gamemode.spectator && entity.getGamemode() == Gamemode.spectator) {
             return;
@@ -138,16 +134,16 @@ public class MobRendererPlayer extends MobRendererBipedArmored<Player>
                 {
                     if(entity.isPlayerSleeping())
                     {
-                        renderLivingLabel(tessellator, entity, s, d, d1 - 1.5D, d2, 64, false);
+                        renderLivingLabel(tessellator, entity, s, x, y - 1.5D, z, 64, false);
                     } else
                     {
-                        renderLivingLabel(tessellator, entity, s, d, d1, d2, 64, false);
+                        renderLivingLabel(tessellator, entity, s, x, y, z, 64, false);
                     }
                 } else
                 {
                     Font font = getFont();
                     GL11.glPushMatrix();
-                    GL11.glTranslatef((float)d + 0.0F, (float)d1 + 2.3F, (float)d2);
+                    GL11.glTranslatef((float) x + 0.0F, (float) y + 2.3F, (float) z);
                     GL11.glNormal3f(0.0F, 1.0F, 0.0F);
                     GL11.glRotatef(-renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
                     GL11.glRotatef(renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
index cedcbb1d5..c270f7617 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererWolf.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.render.entity;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.model.ModelWolf;
@@ -11,6 +12,8 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
+import org.useless.dragonfly.DisplayPos;
 
 public class MobRendererWolf extends MobRenderer<MobWolf>
 {
@@ -52,30 +55,22 @@ public class MobRendererWolf extends MobRenderer<MobWolf>
     }
 
     @Override
-    protected void renderAdditional(MobWolf entity, float f){
-        ItemStack itemstack = entity.getWolfHeldItem();
+    protected void renderAdditional(MobWolf entity, float partialTick){
+        ItemStack itemstack = entity.getHeldItem();
 
         if(itemstack != null && itemstack.getItem() != null) {
             GL11.glPushMatrix();
             modelWolfMain.wolfHeadMain.translateTo(0.0625F);
-            GL11.glTranslatef(-0.0625F, 0.4375F, 0.0625F);
-            float scale;
-            if (itemstack.itemID > 0 && itemstack.itemID < Blocks.blocksList.length && BlockModelDispatcher.getInstance().getDispatch(Blocks.blocksList[itemstack.itemID]).shouldItemRender3d()) {
-                scale = 0.35F;
-                GL11.glTranslatef(0.075F, -0.3F, -0.35F);
-                scale *= 0.75F;
-                GL11.glRotatef(45F, 0.0F, 1.0F, 0.0F);
-                GL11.glScalef(scale, -scale, scale);
-
-            } else {
-                scale = 0.375F;
-                GL11.glTranslatef(0.25F, -0.25F, -0.35F);
-                GL11.glScalef(scale, scale, scale);
-                GL11.glRotatef(50F, 0.0F, 0.0F, 1.0F);
-                GL11.glRotatef(-90F, 1.0F, 0.0F, 0.0F);
-                GL11.glRotatef(70F, 1.0F, 0.0F, 1.0F);
-            }
-            ItemModelDispatcher.getInstance().getDispatch(itemstack).renderItem(Tessellator.instance, renderDispatcher.itemRenderer, entity, itemstack);
+            GL11.glScalef(1, -1, 1);
+            GL11.glTranslatef(0.5f/16f, -2.5f/16f, -2/16f);
+            GL11.glRotatef(-2.5f, 0, 0, 1);
+            GL11.glRotatef(45, 0, 1, 0);
+            GL11.glRotatef(-90, 1, 0, 0);
+            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+            GL11.glEnable(GL11.GL_BLEND);
+            ItemModelDispatcher.getInstance().getDispatch(itemstack).render(Tessellator.instance, entity, itemstack, DisplayPos.GROUND, Minecraft.getMinecraft().gameSettings.items3D.value, 1, entity.getBrightness(partialTick), 1f, partialTick, true);
+            GL11.glDisable(GL11.GL_BLEND);
+            GL11.glDisable(GL12.GL_RESCALE_NORMAL);
             GL11.glPopMatrix();
         }
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
index 6cf37eed3..b389474db 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModel.java
@@ -1,43 +1,106 @@
 package net.minecraft.client.render.item.model;
 
-import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.EntityRenderDispatcher;
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.ItemRenderer;
+import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-
-import java.util.Random;
+import org.lwjgl.opengl.GL11;
+import org.lwjgl.opengl.GL12;
+import org.useless.dragonfly.DisplayPos;
 
 public abstract class ItemModel {
     public Item item;
     public ItemModel(Item item){
         this.item = item;
     }
-    public abstract void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, Player player, ItemStack stack, float partialTick);
-    public void renderItem(Tessellator tessellator, ItemRenderer renderer, Mob entityLiving, ItemStack itemStack){
-        final Minecraft mc = Minecraft.getMinecraft();
-        float brightness = entityLiving.getBrightness(1.0f);
-        renderItem(tessellator, renderer, itemStack, entityLiving, brightness, true);
+
+    public abstract void render(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, float brightness, float alpha, float partialTick, boolean mirrorX); // TODO figure out if theres a way to not explicitly need to mirrorX in the model itself
+    public abstract void renderItemOverlayIntoGUI(@NotNull Tessellator tessellator, @NotNull Font font, @NotNull TextureManager textureManager, @NotNull ItemStack itemstack, int x, int y, @Nullable String override, float alpha);
+
+    public void renderGui(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, int x, int y, float brightness, float alpha, float partialTick) {
+        GL11.glPushMatrix();
+        GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
+        GL11.glDisable(GL11.GL_LIGHTING);
+        GL11.glEnable(GL11.GL_BLEND);
+        GL11.glEnable(GL11.GL_CULL_FACE);
+        GL11.glTranslatef(x + 8, y + 8, 0);
+        GL11.glScalef(16, -16, 1);
+        render(tessellator, holder, itemStack, DisplayPos.GUI, false, 1, brightness, alpha, partialTick, false);
+        GL11.glEnable(GL11.GL_LIGHTING);
+        GL11.glDisable(GL11.GL_CULL_FACE);
+        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glPopMatrix();
     }
-    public abstract void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, @Nullable Entity entity, float brightness, boolean handheldTransform);
-    public abstract void renderItemThirdPerson(Tessellator tessellator, ItemRenderer renderer, Entity entity, ItemStack itemstack, boolean handheldTransform);
-    public void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemstack, int x, int y, float alpha) {
-        renderItemIntoGui(tessellator, font, textureManager, itemstack, x, y, 1.0f, alpha);
+
+    public void renderItemEntity(@NotNull Tessellator tessellator, @NotNull ItemStack itemStack, boolean items3d, int clusterSize, int ticks, float yaw, float brightness, float alpha, float partialTick) {
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        GL11.glEnable(GL11.GL_BLEND);
+        if (items3d) {
+            GL11.glRotated(yaw, 0, 1, 0);
+        } else {
+            GL11.glRotatef(180F - EntityRenderDispatcher.instance.viewLerpYaw, 0.0F, 1.0F, 0.0F);
+        }
+        render(tessellator, null, itemStack, DisplayPos.GROUND, items3d, clusterSize, brightness, alpha, partialTick, false);
+        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
-    public abstract void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemStack, int x, int y, float brightness, float alpha);
-    public void renderItemOverlayIntoGUI(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemstack, int x, int y, float alpha) {
-        renderItemOverlayIntoGUI(tessellator, font, textureManager, itemstack, x, y, null, alpha);
+
+    public void renderFirstPerson(@NotNull Tessellator tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, float brightness, float alpha, float partialTick) {
+        GL11.glPushMatrix();
+        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+        final float swingProgress = player.getSwingProgress(partialTick);
+        final float animationProgress2 = MathHelper.sin(swingProgress * MathHelper.PI);
+        final float animationProgress = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
+
+        if (player.isLeftHanded()) {
+            final float xOff = 9/16f;
+            final float yOff = -8.25f/16f -(1.0F - itemRenderer.getEquippedProgress(partialTick)) * 0.6F;
+            final float zOff = -0.775f;
+
+            GL11.glScalef(-1, 1, 1);
+            GL11.glTranslatef(-animationProgress * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -animationProgress2 * 0.2F); // Makes swing travel in an arc
+            GL11.glTranslatef(xOff, yOff, zOff);
+
+            float animationProgress3 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
+            GL11.glRotatef(45, 0, 1, 0);
+            GL11.glRotatef(-animationProgress3 * 20F, 0.0F, 1.0F, 0.0F);
+            GL11.glRotatef(-animationProgress * 20F, 0.0F, 0.0F, 1.0F);
+            GL11.glRotatef(-animationProgress * 80F, 1.0F, 0.0F, 0.0F);
+            GL11.glRotatef(-45, 0, 1, 0);
+
+            GL11.glFrontFace(GL11.GL_CW);
+            render(tessellator,player, itemStack, DisplayPos.FIRST_PERSON_LEFT_HAND, true, 1, brightness, alpha, partialTick, true);
+            GL11.glFrontFace(GL11.GL_CCW);
+        } else {
+            final float xOff = 9/16f;
+            final float yOff = -8.25f/16f -(1.0F - itemRenderer.getEquippedProgress(partialTick)) * 0.6F;
+            final float zOff = -0.775f;
+
+            GL11.glTranslatef(-animationProgress * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -animationProgress2 * 0.2F); // Makes swing travel in an arc
+            GL11.glTranslatef(xOff, yOff, zOff);
+
+            float animationProgress3 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
+            GL11.glRotatef(45, 0, 1, 0);
+            GL11.glRotatef(-animationProgress3 * 20F, 0.0F, 1.0F, 0.0F);
+            GL11.glRotatef(-animationProgress * 20F, 0.0F, 0.0F, 1.0F);
+            GL11.glRotatef(-animationProgress * 80F, 1.0F, 0.0F, 0.0F);
+            GL11.glRotatef(-45, 0, 1, 0);
+
+            render(tessellator,player, itemStack, DisplayPos.FIRST_PERSON_RIGHT_HAND, true, 1, brightness, alpha, partialTick, false);
+        }
+        GL11.glPopMatrix();
+        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
-    public abstract void renderItemOverlayIntoGUI(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemstack, int x, int y, String override, float alpha);
-    public abstract void renderAsItemEntity(Tessellator tessellator, @Nullable Entity entity, Random random, ItemStack itemstack, int renderCount, float yaw, float brightness, float partialTick);
-    public abstract void renderItemInWorld(Tessellator tessellator, Entity entity, ItemStack itemStack, float brightness, float alpha, boolean worldTransform);
     public abstract IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack);
 }
